#include <iostream>
#include <vector>
#include <cmath>
#define endl '\n'

using namespace std;

void speed() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

auto calculate_indexes(pair<int, int> request) {
    
    pair<int, int> between = { 0,0 };

    int n = 1;
    bool ready[] = { false, false };
    while (true) {
        if (n*n >= request.first && !ready[0]) {
            between.first = n;
            ready[0] = true;
        }
        if (n*n >= request.second && !ready[1]) {
            between.second = n;
            ready[1] = true;
        }
        if (ready[0] && ready[1])
            break;
        n++;
    }

    return between;
}

auto caluclate_sum_between_indexes(pair<int, int> indexes) {
    long long sum = 0;

    for (int i = 0; i < indexes.second - indexes.first - 1; i++) {
        sum += (indexes.first + i + 1) * (indexes.first + i + 1);
    }
    return sum;
}

auto calculate_sum_of_index(int index, int offset, bool reverced) {
    long long sum = 0;
    int exp = 0;
    for (int i = 0; i < 2 * (index - 1) + 1; i++) {
        if (i < (2 * (index - 1) + 1) / 2 + 1)
            exp++;
        else
            exp--;
       
        if (i >= offset - 1 && !reverced)
            sum += exp;
        if (i < offset && reverced)
            sum += exp;
        
    }
    return sum;
}

auto calculate_sum_of_single_index(int index, int offset, int size) {
    long long sum = 0;
    int exp = 0;
    for (int i = 0; i < 2 * (index - 1) + 1; i++) {
        if (i < (2 * (index - 1) + 1) / 2 + 1)
            exp++;
        else
            exp--;

        if (i > offset && i < offset + size)
            sum += exp;

    }
    return sum;
}

int main()
{
    speed();

    int request_amount;
    cin >> request_amount;

    vector<pair<int, int>> requests;
    requests.reserve(request_amount);

    for (int i = 0; i < request_amount; i++) {
        int x, y;
        cin >> x >> y;
        requests.push_back({ x, y });
    }

    for (auto request : requests) {
        auto indexes = calculate_indexes(request);
        long long sum = caluclate_sum_between_indexes(indexes);

        if (indexes.first == indexes.second) {
            cout <<calculate_sum_of_single_index(indexes.first, request.first - pow(indexes.first - 1, 2) - 2, request.second - request.first + 2);
            continue;
        }

        sum += calculate_sum_of_index(indexes.first, ((indexes.first - 1) * 2 + 1) - (pow(indexes.first, 2) - request.first), false);
        sum += calculate_sum_of_index(indexes.second, request.second - request.first - (pow(indexes.first, 2) - request.first), true);

        cout << sum << '\n';
    }


    
    return 0;
}