#include <iostream>
#include <array>
#include <cstdlib>
#include <iomanip>
#include <ctime>
#include <chrono>
#include <cmath>

using namespace std;

void print_seq(int* p, int& s)
{
    for(int j = 0; j != s; ++j) // print it back out
        std::cout << "p[" << j << "] == " << p[j] << '\n';
}

void print_pair_seq(pair<int, int>* p, int& s)
{
    for(int j = 0; j != s; ++j) // print it back out
        std::cout << "p[" << j << "] == " << p[j].first << " " << p[j].second << '\n';
}

int get_seq_len(int x)
{
    return x + (x-1);
}

pair<int, int> iterate_until_el_no(int l)
{
    int total_len = 0;
    int i = 1;
    for(; total_len <= l; i++)
    {
        total_len += get_seq_len(i);
    }

    return make_pair(i, total_len);
}

int* get_seq(int x, int* p, int offset, int max_)
{
    const unsigned int seq_len = get_seq_len(x);
    //cout << seq_len << "\n" << endl;

    bool is_inc = true;
    int next_i;
    for(int i = 0; i < seq_len; i++)
    {
        if(i == x)
        {
            is_inc = false;
            //printf("switch\n");
        }
        if(offset+i == max_)
            break;
        if(!is_inc)
        {
            //printf("decr\n");
            next_i = p[offset + x - (i - x + 2)];
            //cout << next_i << " " << offset << " " << x << " " << offset + x - (i - x + 1) << "\n" << endl;

        }
        else
        {
            //printf("incr\n");
            next_i = i + 1;
            //cout << i << "\n" << endl;

        }
        new(p+offset+i) int(next_i);
    }

    return p;
}

int count_sum(int* seqs, int seq_no, int total_els, int l, int r)
{
    int sum = 0;

    for(int i = l-1; i < r; i++)
    {
        sum += seqs[i];
        //cout << "summing: " << seqs[i] << endl;

    }
    return sum;
}

int main()
{
    int q;
    cin >> q;

    pair<int, int>* queries = (pair<int, int>*)malloc(q * sizeof(pair<int, int>));

    int max_ = -1;
    int l, r;
    for(int i = 0; i < q; i++)
    {
        cin >> l >> r;
        if(l > max_)
        {
            max_ = l;
        }
        if(r > max_)
        {
            max_ = r;
        }
        //cout << l << " " << r << endl;
        new(queries+i) pair<int, int>(l, r);
    }

    //print_pair_seq(queries, q);
    //print_pair_seq(queries, q);
    //std::chrono::steady_clock::time_point start = std::chrono::steady_clock::now();

    int* seqs = (int*)malloc(max_ * sizeof(int));
    int total_len = 0;
    for(int i = 1; total_len < max_; i++)
    {
        get_seq(i, seqs, total_len, max_);
        total_len += get_seq_len(i);
    }

    print_seq(seqs, max_);

    for(int i = 0; i < q; i++)
    {
        pair<int, int> query = queries[i];

        pair<int, int> l_seq_info = iterate_until_el_no(query.first);
        int l_seq_no = l_seq_info.first, l_total_els = l_seq_info.second;

        cout << count_sum(seqs, l_seq_no, l_total_els, query.first, query.second) << endl;
        //cout << "res: " << count_sum(seqs, l_seq_no, l_total_els, query.first, query.second) % (int)(std::pow(10, 9) + 7) << endl;
    }

    //std::chrono::steady_clock::time_point end = std::chrono::steady_clock::now();
    //std::cout << "Execution took "
    //          << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
    //          << "ms.\n";


    free(seqs);
    free(queries);

    return 0;
}
