# include <iostream>
# include <cassert>
using namespace std;

const long long MOD=1e9+7;
const int MAX=2e6+11,D=2e6;

long long cnt[MAX];
long long sum[MAX];

void precalc()
{
    for(long long i=1;i<=D;i++)
    {
        cnt[i]=i*2-1;
        cnt[i]+=cnt[i-1];

        sum[i]=i*i;
        sum[i]+=sum[i-1];
        //if(sum[i]!=i*(i+1)*(i+3)/6) cout<<i<<"\n";
        sum[i]%=MOD;
    }
}

int get_seq(long long id)
{
    int l=1,r=D,ans=1;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(id<=cnt[mid])
        {
            ans=mid;
            r=mid-1;
        }
        else l=mid+1;
    }

    return ans;
}

long long get_sum(long long seq, long long l, long long r)
{
    if(l>2e6 or r>2e6) assert(0);
    if(l<=seq and r<=seq) return ((l+r)*(r-l+1)/2)%MOD;
    if(seq<l and seq<r) return get_sum(seq,seq*2-r,seq*2-l);
    return (get_sum(seq,l,seq)+get_sum(seq,seq+1,r))%MOD;
}

long long solve()
{
    long long l,r;
    cin>>l>>r;

    long long idL=get_seq(l),idR=get_seq(r);
    if(idL==idR) return get_sum(idL,l-cnt[idL-1],r-cnt[idL-1]);
    else
    {
        long long ans=0;
        if(idL+1<=idR-1)
        {
            ans+=(sum[idR-1]-sum[idL]+MOD);
            ans%=MOD;
        }
        ans+=get_sum(idL,l-cnt[idL-1],cnt[idL]-cnt[idL-1]);
        ans+=get_sum(idR,1,r-cnt[idR-1]);
        ans%=MOD;
        return ans;
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    precalc();

    int t;
    cin>>t;
    while(t--)
    {
        long long ans=solve();
        cout<<ans%MOD<<"\n";
    }

    return 0;
}

