# include <iostream>
# include <cassert>
using namespace std;

const long long MOD=1e9+7;
const int MAX=2e6+11,D=1e9;

struct matrix
{
    long long tab[4][4];

    matrix()
    {
        for(int i=0;i<4;i++)
        {
            for(int j=0;j<4;j++)
            {
                tab[i][j]=0;
            }
        }
    }

    void zero()
    {
        for(int i=0;i<4;i++)
        {
            for(int j=0;j<4;j++)
            {
                tab[i][j]=0;
            }
        }
    }

    void idenity()
    {
        for(int i=0;i<4;i++) tab[i][i]=1;
    }

    void make_rec()
    {
        tab[0][0]=1;tab[0][1]=2;tab[0][2]=1;tab[0][3]=1;
        tab[1][1]=1;tab[1][3]=1;
        tab[2][2]=1;tab[2][1]=2;tab[2][3]=1;
        tab[3][3]=1;
    }

    void make_base()
    {
        tab[0][0]=1;
        tab[1][0]=1;
        tab[2][0]=1;
        tab[3][0]=1;
    }

    matrix friend operator * (matrix A, matrix B)
    {
        matrix res;
        for(int i=0;i<4;i++)
        {
            for(int j=0;j<4;j++)
            {
                for(int k=0;k<4;k++)
                {
                    res.tab[i][j]+=A.tab[i][k]*B.tab[k][j];
                    res.tab[i][j]%=MOD;
                }
            }
        }

        return res;
    }
};

matrix starter_pack;
matrix base_power[60];

void precalc()
{
    starter_pack.make_base();
    base_power[0].idenity();
    base_power[1].make_rec();
    for(int i=2;i<60;i++) base_power[i]=base_power[i-1]*base_power[1];
}

long long Sum(long long power)
{
    if(power<=0) return 0;
    power--;

    matrix res;
    res.idenity();
    int pw=1;
    while(power)
    {
        if(power&1) res=res*(base_power[pw]);

        power/=2;
        pw++;
    }

    return (res*starter_pack).tab[0][0];
}

long long cnt(long long x)
{
    if(x<=0) return 0;
    return x*(x+1)-x;
}

int get_seq(long long id)
{
    int l=1,r=D,ans=1;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(id<=cnt(mid))
        {
            ans=mid;
            r=mid-1;
        }
        else l=mid+1;
    }

    return ans;
}

long long get_sum(long long seq, long long l, long long r)
{
    if(l<=seq and r<=seq) return ((l+r)*(r-l+1)/2)%MOD;
    if(seq<l and seq<r) return get_sum(seq,seq*2-r,seq*2-l);
    return (get_sum(seq,l,seq)+get_sum(seq,seq+1,r))%MOD;
}

long long solve()
{
    long long l,r;
    cin>>l>>r;

    //if(l>1e12 or r>1e12) assert(0);
    //if(l!=r) assert(0);

    long long idL=get_seq(l),idR=get_seq(r);
    if(idL==idR) return get_sum(idL,l-cnt(idL-1),r-cnt(idL-1));
    else
    {
        long long ans=0;
        if(idL+1<=idR-1)
        {
            ans+=(Sum(idR-1)-Sum(idL)+MOD);
            ans%=MOD;
        }
        ans+=get_sum(idL,l-cnt(idL-1),cnt(idL)-cnt(idL-1));
        ans+=get_sum(idR,1,r-cnt(idR-1));
        ans%=MOD;
        return ans;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    precalc();

    int t;
    cin>>t;
    while(t--)
    {
        long long ans=solve();
        cout<<ans<<"\n";
    }

    return 0;
}


