# include <iostream>
# include <vector>
using namespace std;

const int MAX=1e5+11;

int n;
vector<int> adj[MAX];
int up[MAX];

void read()
{
    cin>>n;
    for(int i=2;i<=n;i++)
    {
        cin>>up[i];
        adj[up[i]].push_back(i);
    }
}

int sz[MAX];

void dfs(int curr)
{
    sz[curr]=1;
    for(int nxt: adj[curr])
    {
        dfs(nxt);
        sz[curr]+=sz[nxt];
    }
}

void find_size()
{
    dfs(1);
}

void solve()
{
    long long ans=0;
    for(int i=1;i<=n;i++)
    {
        long long l=0,r=n+1;
        long long u=up[i];
        while(u!=0)
        {
            if(u<i) l=max(l,u);
            else r=min(r,u);

            u=up[u];
        }

        ans+=sz[i]*(i-l)*(r-i);
    }

    cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    find_size();
    solve();

    return 0;
}

