#include <iostream>
using namespace std;
typedef long long ll;
const ll mod = 1e9 + 7;
const ll maxN = 3005;
char in[maxN];
ll dp[maxN][maxN];
struct Fenwick {
    Fenwick() {};
    ~Fenwick() {};

    void update(int idx, int val) {
        while (idx < maxN) {
            item[idx] += val;
            item[idx] %= mod;
            idx += ((~idx) + 1) & idx;
        }
    }
    int query(int idx) {
        int ans = 0;
        while (idx) {
            ans += item[idx];
            ans %= mod;
            idx &= idx - 1;
        }
        return ans;
    }

    int item[maxN];
};
Fenwick fen[maxN];

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n;
    cin >> n;
    cin >> in;
    dp[0][1] = 1;
    fen[0].update(1, 1);
    for (int i = 1; i < n; i++) {
        for (int j = 1; j <= i + 1; j++) {
            if (in[i - 1] == '<') {
                ll add = fen[i - 1].query(j - 1);
                dp[i][j] += add;
                fen[i].update(j, add);
//                for (int k = 1; k < j; k++) {
//                    dp[i][j] += dp[i - 1][k];
//                    dp[i][j] %= mod;
//                }
            } else {
                ll add = (fen[i - 1].query(i + 1) - fen[i - 1].query(j - 1) + mod) % mod;
                dp[i][j] += add;
                fen[i].update(j, add);
            }
        }
    }

    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += dp[n - 1][i];
        ans %= mod;
    }
    cout << ans << '\n';
}
