#include <iostream>
#include <deque>
#include <vector>
using namespace std;
typedef long long ll;
const ll maxN = 1e5 + 10, sqrtMaxN = 320;
int clParL[maxN], clParR[maxN];
ll dist[maxN], par[maxN], sz[maxN];
vector<ll> child[maxN];
ll n, ans = 0, curFLSz = 0;
struct FastList {
    FastList() {}
    ~FastList() {}

    void insert(int idx, int val) {
        int curB = idx  / bucketSz;
        item[curB].insert(item[curB].begin() + (idx % bucketSz), val);
        while (item[curB].size() > bucketSz) {
            int backEl = item[curB].back();
            item[curB + 1].push_front(backEl);
            curB++;
        }
    }

    void erase(int idx) {
        int curB = idx  / bucketSz;
        item[curB].erase(item[curB].begin() + (idx % bucketSz));
        while (item[curB + 1].size() > 0 && item[curB].size() < bucketSz) {
            int backEl = item[curB + 1].front();
            item[curB].push_back(backEl);
            curB++;
        }
    }


    int getEl(int idx) const {
        return item[idx / bucketSz][idx % bucketSz];
    }

    const int bucketSz = sqrtMaxN;
    deque<int> item[maxN / sqrtMaxN];
} fl;

int bin_searchFL(int x, int sz) {
    int l = -1, r = sz;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (fl.getEl(m) < x) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

void init(ll cur, ll distFromRoot) {
    dist[cur] = distFromRoot;
    for (ll v : child[cur]) {
        init(v, distFromRoot + 1);
        sz[cur] += sz[v];
    }
    sz[cur]++;
}
void initClPar(int cur) {
    int res = bin_searchFL(cur, curFLSz);
    if (res >= curFLSz) {
        clParR[cur] = n + 1;
    } else {
        clParR[cur] = fl.getEl(res);
    }
    if (res <= 0) {
        clParL[cur] = 0;
    } else {
        clParL[cur] = fl.getEl(res - 1);
    }
    fl.insert(res, cur);
    curFLSz++;

    for (int v : child[cur]) {
        initClPar(v);
    }
    fl.erase(res);
    curFLSz--;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (ll i = 2; i <= n; i++) {
        cin >> par[i];
        child[par[i]].push_back(i);
    }
    init(1, 0);
    initClPar(1);
//    for (int i = 1; i <= n; i++) {
//        cout << i << ' ' << clParL[i] << ' ' << clParR[i] << '\n';
//    }
    for (int i = 1; i <= n; i++) {
        ans += sz[i] * (i - clParL[i]) * (clParR[i] - i);
    }
    cout << ans << '\n';
}
