#include <iostream>
#include <cmath>
#include <deque>
#include <vector>
using namespace std;
typedef long long ll;
const ll maxN = 1e5 + 10;
ll clParL[maxN], clParR[maxN];
ll dist[maxN], par[maxN], sz[maxN];
vector<ll> child[maxN];
ll n, ans = 0, curFLSz = 0, maxDist = 0;
struct FastList {
    FastList() {}
    ~FastList() {}

    void init(int buckSz) {
        bucketSz = buckSz;
        item = new deque<ll>[bucketSz + 5]();
    }

    void insert(ll idx, ll val) {
        ll curB = idx  / bucketSz;
        item[curB].insert(item[curB].begin() + (idx % bucketSz), val);
        while (item[curB].size() > bucketSz) {
            ll backEl = item[curB].back();
            item[curB + 1].push_front(backEl);
            curB++;
        }
    }
    void erase(ll idx) {
        ll curB = idx  / bucketSz;
        item[curB].erase(item[curB].begin() + (idx % bucketSz));
        while (item[curB + 1].size() > 0 && item[curB].size() < bucketSz) {
            ll backEl = item[curB + 1].front();
            item[curB].push_back(backEl);
            curB++;
        }
    }
    ll getEl(ll idx) const {
        return item[idx / bucketSz][idx % bucketSz];
    }

    int bucketSz;
    deque<ll>* item;
} fl;

ll bin_searchFL(ll x, ll sz) {
    ll l = -1, r = sz;
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        if (fl.getEl(m) < x) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

void init(ll cur, ll distFromRoot) {
    dist[cur] = distFromRoot;
    for (ll v : child[cur]) {
        init(v, distFromRoot + 1);
        sz[cur] += sz[v];
    }
    sz[cur]++;
    maxDist = max(maxDist, dist[cur]);
}
void initClPar(ll cur) {
    ll res = bin_searchFL(cur, curFLSz);
    if (res >= curFLSz) {
        clParR[cur] = n + 1;
    } else {
        clParR[cur] = fl.getEl(res);
    }
    if (res <= 0) {
        clParL[cur] = 0;
    } else {
        clParL[cur] = fl.getEl(res - 1);
    }
    fl.insert(res, cur);
    curFLSz++;

    for (ll v : child[cur]) {
        initClPar(v);
    }
    fl.erase(res);
    curFLSz--;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (ll i = 2; i <= n; i++) {
        cin >> par[i];
        child[par[i]].push_back(i);
    }
    init(1, 0);
    fl.init((ll)sqrt(maxDist) + 5);
    initClPar(1);
    for (ll i = 1; i <= n; i++) {
        ans += sz[i] * (i - clParL[i]) * (clParR[i] - i);
    }
    cout << ans << '\n';
}
