#include <iostream>
#include <vector>
#include <map>
using namespace std;
typedef long long ll;
const ll maxN = 1e5 + 10;
ll clParL[maxN], clParR[maxN];
ll dist[maxN], par[maxN], sz[maxN];
map<ll, ll> hack1;
map<ll, ll> hack2;
vector<ll> child[maxN];
ll n, ans = 0;

void init(ll cur, ll distFromRoot) {
    dist[cur] = distFromRoot;
    for (ll v : child[cur]) {
        init(v, distFromRoot + 1);
        sz[cur] += sz[v];
    }
    sz[cur]++;
}
void initClPar(ll cur) {
    auto it = hack1.upper_bound(cur);
    if (it == hack1.end()) {
        clParR[cur] = n + 1;
    } else {
        clParR[cur] = it->first;
//        cout << cur << ' ' << it->first << " -\n";
    }
    it = hack2.upper_bound(-cur);
    if (it == hack2.end()) {
        clParL[cur] = 0;
    } else {
        clParL[cur] = -it->first;
//        cout << cur << ' ' << it->first << " |\n";
    }

    hack1.insert({ cur, cur });
    hack2.insert({ -cur, -cur });

    for (ll v : child[cur]) {
        initClPar(v);
    }
    hack1.erase(hack1.find(cur));
    hack2.erase(hack2.find(-cur));
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (ll i = 2; i <= n; i++) {
        cin >> par[i];
        child[par[i]].push_back(i);
    }
    init(1, 0);
    initClPar(1);
    for (ll i = 1; i <= n; i++) {
        ans += sz[i] * (i - clParL[i]) * (clParR[i] - i);
    }
    cout << ans << '\n';
}

