# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 1e5 + 1;
int N;
int Parent[MAXN];
vector<int> Graph[MAXN];
string dp[MAXN];
string Answer = "";
ll Tree[MAXN];

string SmallSum(string A, ll B)
{
    string Ans = "";
    reverse(A.begin(), A.end());
    ll Prenos = B;

    for(int i = 0; i < (int)A.size() || Prenos != 0; i++)
    {
        ll Current = Prenos;

        if(i < (int)A.size())
        {
            Current += (A[i] - '0');
        }

        Ans.push_back(Current % 10 + '0');
        Prenos = Current / 10;
    }

    reverse(Ans.begin(), Ans.end());
    return Ans;
}


string BigSum(string A, string B)
{
    string Ans = "";
    reverse(A.begin(), A.end());
    reverse(B.begin(), B.end());
    ll Prenos = 0;

    for(int i = 0; i < max((int)A.size(), (int)B.size()) || Prenos != 0; i++)
    {
        ll Current = Prenos;

        if(i < (int)A.size())
        {
            Current += (A[i] - '0');
        }

        if(i < (int)B.size())
        {
            Current += (B[i] - '0');
        }

        Ans.push_back(Current % 10 + '0');
        Prenos = Current / 10;
    }

    reverse(Ans.begin(), Ans.end());
    return Ans;
}

void Update(int Index, int Add)
{
    while(Index <= N)
    {
        Tree[Index] += Add;
        Index += (Index & (-Index));
    }
}

ll Query(int Index)
{
    ll Sum = 0;

    while(Index >= 1)
    {
        Sum += Tree[Index];
        Index -= (Index & (-Index));
    }

    return Sum;
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N;

    for(int U = 2; U <= N; U++)
    {
        cin >> Parent[U];
        Graph[Parent[U]].push_back(U);
    }
}

void Dfs(int U)
{
    dp[U] = dp[Parent[U]];

    int left = U, right = N - U + 1;

    int l = 1, r = U;
    int mid;
    int answer = -1;

    while(l <= r)
    {
        mid = (l + r) / 2;

        if(Query(U) - Query(mid - 1) <= 0)
        {
            answer = mid;
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    left = U - answer + 1;
    l = U, r = N;
    mid = 0;
    answer = -1;
    while(l <= r)
    {
        mid = (l + r) / 2;

        if(Query(mid) - Query(U - 1) <= 0)
        {
            answer = mid;
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    right = answer - U + 1;

    dp[U] = SmallSum(dp[U], (ll)(left * right));
    Answer = BigSum(Answer, dp[U]);
    Update(U, 1);

    for(auto& V : Graph[U])
    {
        Dfs(V);
    }

    Update(U, -1);
}

void Solve()
{
    Dfs(1);
    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

