#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << "; "

#ifndef LOCAL
#define cerr if(false) cerr
#define sync_with_stdio(true) sync_with_stdio(false)
#endif

const long long INF = 1e9 + 9;
const long long MOD = 1e9 + 7;

const long long MAX_N = 1e6 + 10;

long long sumTo (long long n) {
    return (n * (n + 1) / 2) % MOD;
}

long long sumAfter (long long n, long long k) {
    if (2 * n <= k) return 0;
    long long sum = 0;
    if (k <= n) {
        sum += sumTo(n) - sumTo(k - 1) + MOD;
        sum %= MOD;
        k = n + 1;
    }

    sum += sumTo(2 * n - k);
    sum %= MOD;

    return sum;
}

long long sumBefore (long long n, long long k) {
    if (2 * n <= k) return 0;
    long long sum = 0;
    if (k >= n) {
        sum += sumTo(n - 1) - sumTo(n - (k - n) - 1) + MOD;
        sum %= MOD;
        k = n;
    }

    sum += sumTo(k);
    sum %= MOD;

    return sum;
}

long long getSquareBefore ( long long x ) {

    if (x <= 0) return -1;
    if (x == 1) return 0;
    if (x <= 4) return 1;
    if (x <= 9) return 2;

    long long l = 1, r = min(x / 2, 1000000000ll), mid, sq = -1;

    if (x > 10000) {l = 100; r = 320;}
    if (x > 100000) {l = 310; r = 1000;}
    if (x > 1000000) {l = 1000; r = 3130;}
    if (x > 10000000) {l = 3030; r = 10000;}
    if (x > 100000000) {l = 10000; r = 31630;}
    if (x > 1000000000) {l = 31530; r = 100000;}
    if (x > 10000000000) {l = 100000; r = 316300;}
    if (x > 100000000000) {l = 316200; r = 1000000;}
    if (x > 1000000000000) {l = 1000000; r = 3162300;}
    if (x > 10000000000000) {l = 3162277; r = 10000000;}
    if (x > 100000000000000) {l = 10000000; r = 31622800;}
    if (x > 1000000000000000) {l = 31622776; r = 100000000;}
    if (x > 10000000000000000) {l = 100000000; r = 316227800;}
    if (x > 100000000000000000) {l = 316227766; r = 1000000000;}
    if (x > 1000000000000000000) {l = 1000000000; r = 10000000000;}

    while (l <= r) {
        mid = (l + r) / 2;
        if (mid * mid < x) {
            sq = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }

    return sq;
}

long long sumOfSquares (long long l, long long r) {
    long long sum = 0;
    for (long long i = l; i <= r; i ++) {
        sum += i * i;
        sum %= MOD;
    }

    return sum;
}

long long getNumber (long long pos) {
    long long sq = getSquareBefore(pos);
    pos -= sq * sq;
    sq ++;

    if (pos <= sq) {
        return pos;
    } else {
        return (sq - (pos - sq));
    }
}

void solve () {
    long long l, r; cin >> l >> r;
    if (l == r) {
        cout << getNumber(l) << endl;
        return;
    }

    long long ans = 0;
    long long sqBL = getSquareBefore(l);
    long long sqBR = getSquareBefore(r);

    if (sqBL == sqBR) {
        ans = sumAfter(sqBL + 1, l - sqBL * sqBL) - sumAfter(sqBR + 1, r - sqBR * sqBR + 1) + MOD;
        ans %= MOD;
        cout << ans << endl;
        return;
    }

    //cerr << "sumAfter(" << sqBL + 1 << ", " << l - sqBL * sqBL << ") = " << sumAfter(sqBL + 1, l - sqBL * sqBL) << endl;
    //cerr << "sumOfSquares(" << sqBL + 2 << ", " << sqBR << ") = " << sumOfSquares(sqBL + 2, sqBR) << endl;
    //cerr << "sumBefore(" << sqBR + 1 << ", " << r - sqBR * sqBR << ") = " << sumBefore(sqBR + 1, r - sqBR * sqBR) << endl;

    ans += sumAfter(sqBL + 1, l - sqBL * sqBL);
    ans %= MOD;
    ans += sumOfSquares(sqBL + 2, sqBR);
    ans %= MOD;
    ans += sumBefore(sqBR + 1, r - sqBR * sqBR);
    ans %= MOD;

    cout << ans << endl;
}

signed main () {
    ios_base::sync_with_stdio(true); cin.tie(nullptr);

    long long t; cin >> t;
    while (t --) solve ();

    return 0;
}
