#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << "; "

#ifndef LOCAL
#define cerr if(false) cerr
#define sync_with_stdio(true) sync_with_stdio(false)
#endif

const long long INF = 1e9 + 9;
const long long MOD = 1e9 + 7;

const long long MAX_N = 1e6 + 10;

long long sumTo (long long n) {
    return (n * (n + 1) / 2) % MOD;
}

long long sumAfter (long long n, long long k) {
    if (2 * n <= k) return 0;
    long long sum = 0;
    if (k <= n) {
        sum += sumTo(n) - sumTo(k - 1) + MOD;
        sum %= MOD;
        k = n + 1;
    }

    sum += sumTo(2 * n - k);
    sum %= MOD;

    return sum;
}

long long sumBefore (long long n, long long k) {
    if (2 * n <= k) return 0;
    long long sum = 0;
    if (k >= n) {
        sum += sumTo(n - 1) - sumTo(n - (k - n) - 1) + MOD;
        sum %= MOD;
        k = n;
    }

    sum += sumTo(k);
    sum %= MOD;

    return sum;
}

long long getSquareBefore ( long long x ) {
    if (x <= 0) return -1;
    if (x == 1) return 0;
    if (x <= 4) return 1;
    if (x <= 9) return 2;

    long long l = 1, r = min(x / 2, 1000000000ll), mid, sq = -1;

    while (l <= r) {
        mid = (l + r) / 2;
        if (mid * mid < x) {
            sq = mid;
            l = mid + 1;
        } else {
            r = mid - 1;
        }
    }

    return sq;
}

long long sumOfSquares (long long l, long long r) {
    long long sum = 0;
    for (long long i = l; i <= r; i ++) {
        sum += i * i;
        sum %= MOD;
    }

    return sum;
}

void solve () {
    long long l, r; cin >> l >> r;
    if (l != r) {
        cout << 5 / 0 << endl;
        return;
    }
    long long pos = l;
    long long sq = getSquareBefore(pos);
    pos -= sq * sq;
    sq ++;
    if (pos <= sq) {
        cout << (pos % MOD) << '\n';
    } else {
        cout << (sq - (pos - sq)) % MOD << '\n';
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

    long long t; cin >> t;
    while (t --) solve ();

    return 0;
}
