#include <iostream>
#include <cmath>

#define ll long long

const ll MOD = 1e9+7;

ll good_sqrt(ll num) {
    ll res = sqrt(num);
    if (res * res > num) return res - 1;
    return res;
}

ll modd(ll num) {
    return num % MOD;
}

ll mod_div2(ll num) {
    if (num % 2 == 0) return num / 2;
    return (num + MOD) / 2;
}

ll mod_div6(ll num) {
    ll t = num;
    while (t % 6 != 0) t += MOD;
    return t / 6;
}

ll prefix_sum_seg(ll idx) {
    ll sq = good_sqrt(idx);
    if ((sq+1) * (sq+1) == (idx+1)) {
        return (2*sq+3) * (sq+1) * (sq+2) / 6;
    }

    return 0;
}

ll prefix_inseg(ll sq, ll res) {
    if (res <= sq) return (1+res+1)*(res+1)/2;
    return (1+sq+1)*(sq+1)/2 + (sq+sq+1-(res-sq))*(res-sq)/2;
}

ll prefix_sum(ll idx) {
    if (idx == -1) return 0;
    ll sq = good_sqrt(idx);
    if ((sq+1) * (sq+1) == (idx+1)) return prefix_sum_seg(idx);

    ll res = idx - sq*sq;
    return prefix_sum_seg(sq*sq-1) + prefix_inseg(sq, res);
}

ll prefix_sum_seg_mod(ll idx) {
    ll sq = good_sqrt(idx);
    if ((sq+1) * (sq+1) == (idx+1)) {
        return mod_div6( modd(modd(modd(2*sq+3) * (sq+1)) * (sq+2)) );
    }

    return 0;
}

ll prefix_inseg_mod(ll sq, ll res) {
    if (res <= sq) return mod_div2( modd(modd(res+2)*(res+1)) );
    return (1+sq+1)*(sq+1)/2 + (sq+sq+1-(res-sq))*(res-sq)/2;
    return mod_div2( modd(modd(res+2)*(res+1)) ) + mod_div2( modd(modd(3*sq+1-res)*(res-sq)) );
}

ll prefix_sum_mod(ll idx) {
    if (idx == -1) return 0;
    ll sq = good_sqrt(idx);
    if ((sq+1) * (sq+1) == (idx+1)) return prefix_sum_seg_mod(idx);

    ll res = idx - sq*sq;
    return modd(prefix_sum_seg_mod(sq*sq-1) + prefix_inseg_mod(sq, res));
}

int main() {
    int q; std::cin >> q;

    for (int i = 0; i < q; i++) {
        ll l, r; std::cin >> l >> r; l--; r--;

//        std::cout << prefix_sum(r) - prefix_sum(l-1) << std::endl;
        std::cout << modd(prefix_sum_mod(r) + MOD - prefix_sum_mod(l-1)) << std::endl;
    }

//    std::cout << get_num(6969696969);
}


