#include <bits/stdc++.h>
using namespace std;

#define endl '\n'

typedef struct TreeNode
{
    int parent;
    vector<int> children;
    vector<int> subtree;
} TreeNode;

TreeNode tree[100000];

void create_subtrees(int a, TreeNode* grandchild)
{
    for(int i=0; i < grandchild->children.size(); i++)
    {
        tree[a].subtree.push_back(grandchild->children[i]);
        create_subtrees(a, &tree[grandchild->children[i]]);
    }
}

int explore(int l, int r)
{
    unordered_set<int> marked;
    for(int i=l; i <= r; i++)
    {
        marked.insert(i);
        for(int j=0; j < tree[i].subtree.size(); j++)
        {
            marked.insert(tree[i].subtree[i]);
        }
    }
    return marked.size();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    int sum = n*n; // every combination with the root

    for(int i = 1; i < n; i++)
    {
        int tmp;
        cin >> tmp;
        tmp--;

        tree[i].parent = tmp;
        tree[tmp].children.push_back(i);
    }

    for(int i=1; i < n; i++) // Creating all the subtrees
    {
        create_subtrees(i, &tree[i]);
    }

    for(int i=1; i < n; i++)
    {
        for(int j=i; j < n; j++)
        {
            sum += explore(i, j);
        }
    }

    cout << sum;

    return 0;
}
