#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;

const ull MOD = 1000000007;
const ull MAXR = 1000000000000000000;
const ull MAXN = 1000000001;
const ull INV_2 = 500000004;

ull gaussSum(ull from, ull to){
    if(from > to){ return 0; }
    ull n = to-from+1;
    ull everySum = (from + to) % MOD;
    ull doubleSum = (everySum * n) % MOD;
    return (doubleSum * INV_2) % MOD;
}

ull fastExp(ull x, ull p){
    ull res = 1;
    while(p != 0){
        if(p%2 == 0){
            x = (x*x) % MOD;
            p /= 2;
        }else{
            res = (res*x) % MOD;
            p--;
        }
    }
    return res;
}

ull modInv(ull n){
    return fastExp(n, MOD-2);
}

ull getNumberBegin(ull n){
    return (((2 * gaussSum(1, n-1)) % MOD) - n + 2) % MOD;
}

ull getWhichNumber(ull idx){
    if(idx <= 4){ return 1 + (idx != 1); }
    ull l = 1, r = MAXN;
    while(l < r-1){
        ull mid = ((l+r) % MOD)/2;
        ull midBegin = getNumberBegin(mid);
        if(midBegin > idx){
            r = mid-1;
        }else if(midBegin == idx){
            return mid;
        }else {
            l = mid;
        }
    }
    return l;
}

void getSeqAndPos(ull idx, ull& seqN, ull& pos, ull& beginIdx, ull& endIdx, ull& val, ull& middle){
    seqN = getWhichNumber(idx);
    beginIdx = getNumberBegin(seqN);
    pos = idx - beginIdx + 1;
    middle = beginIdx + seqN - 1;
    endIdx = beginIdx + (2 * seqN) - 1 - 1;
    val = pos;
    if(pos > seqN){
        val = 2 * seqN - pos;
    }
}

int main(){
    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        int l, r;
        cin >> l >> r;
        ull sum = 0;

        ull seqN, pos, beginIdx, endIdx, val, middle;
        getSeqAndPos(l, seqN, pos, beginIdx, endIdx, val, middle);
        ull curr = l;
        while(curr <= r){
            if(endIdx <= r){
                if(curr <= middle){ /// to the middle
                    sum = (sum + gaussSum(pos, seqN)) % MOD;
                }
                sum = (sum + gaussSum(1, seqN-1)) % MOD;
                curr = endIdx + 1;
                seqN++; pos = 1; beginIdx = curr; val = 1;
                endIdx = beginIdx + (2 * seqN) - 2;
                middle = beginIdx + seqN - 1;
            }else{
                if(curr <= middle){
                    if(middle <= r){
                        sum = (sum + gaussSum(pos, seqN)) % MOD;
                        curr = middle+1;
                    }else{
                        sum = (sum + gaussSum(pos, pos+(r-curr))) % MOD;
                        curr = r+1;
                    }
                }else{
                    sum = (sum + gaussSum(2 * seqN - (pos+(r-curr)), seqN)) % MOD;
                    curr = r+1;
                }
            }
        }
        cout << sum << '\n';
    }
    return 0;
}
