#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;

const ull MOD = 1000000007;
const ull MAXR = 1000000000000000000;
const ull MAXN = 1000000001;
const ull INV_2 = 500000004;

ull gaussSum(ull from, ull to){
    if(from > to){ return 0; }
    ull n = to-from+1;
    ull everySum = (from + to) % MOD;
    ull doubleSum = (everySum * n) % MOD;
    return (doubleSum * INV_2) % MOD;
}

ull fastExp(ull x, ull p){
    ull res = 1;
    while(p != 0){
        if(p%2 == 0){
            x = (x*x) % MOD;
            p /= 2;
        }else{
            res = (res*x) % MOD;
            p--;
        }
    }
    return res;
}

ull modInv(ull n){
    return fastExp(n, MOD-2);
}

ull getNumberBegin(ull n){
    return (((2 * gaussSum(1, n-1)) % MOD) - n + 2) % MOD;
}

ull getWhichNumber(ull idx){
    if(idx <= 4){ return 1 + (idx != 1); }
    ull l = 1, r = MAXN;
    while(l < r-1){
        ull mid = ((l+r) % MOD)/2;
        ull midBegin = getNumberBegin(mid);
        if(midBegin > idx){
            r = mid-1;
        }else if(midBegin == idx){
            return mid;
        }else {
            l = mid;
        }
    }
    return l;
}

void getSeqAndPos(ull idx, ull& seqN, ull& pos, ull& beginIdx, ull& endIdx, ull& val, ull& middle){
    seqN = getWhichNumber(idx);
    beginIdx = getNumberBegin(seqN);
    pos = idx - beginIdx + 1;
    middle = beginIdx + seqN - 1;
    endIdx = beginIdx + (2 * seqN) - 1 - 1;
    val = pos;
    if(pos > seqN){
        val = 2 * seqN - pos;
    }
}

/**
    1, 1, 2, 1, 1, 2, 3, 2, 1, 1, 2, 3, 4, 3, 2, 1, 1, 2, 3, 4, 5, 4, 3, 2, 1,
    |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
*/

ull solve(ull l, ull r){
    ull sum = 0;
    ull seqN, pos, beginIdx, endIdx, val, middle;
    getSeqAndPos(l, seqN, pos, beginIdx, endIdx, val, middle);
    ull curr = l;
    while(curr <= r){
//        cout << curr << ' ' << seqN << ' ' << beginIdx << ' ' << middle << ' ' << endIdx << ' ' << pos << ' ' << val << ' ' << r << '\n';
        if(curr == beginIdx && endIdx <= r){
            sum = (sum + (2*gaussSum(1, seqN-1) % MOD)) % MOD;
            sum = (sum + seqN) % MOD;
            curr = endIdx + 1;
            seqN++; pos = 1; beginIdx = curr; val = 1;
            endIdx = beginIdx + (2 * seqN) - 2;
            middle = beginIdx + seqN - 1;
        }
        if(endIdx <= r){
            if(curr <= middle){ /// to the middle
                sum = (sum + gaussSum(val, seqN)) % MOD;
            }
            sum = (sum + gaussSum(1, seqN-1)) % MOD;
            curr = endIdx + 1;
            seqN++; pos = 1; beginIdx = curr; val = 1;
            endIdx = beginIdx + (2 * seqN) - 2;
            middle = beginIdx + seqN - 1;
        }else{
            if(curr <= middle){
                if(middle <= r){
                    sum = (sum + gaussSum(val, seqN)) % MOD;
                    curr = middle+1;
                    pos = seqN+1;
                    val = seqN-1;
                }else{
                    sum = (sum + gaussSum(val, pos+(r-curr))) % MOD;
                    curr = r+1;
                    val = pos+(r-curr)+1;
                    pos = pos+(r-curr)+1;
                }
            }else{
//                cout << "from: " << 2 * seqN - (pos+(r-curr)) << ", to: " << val << '\n';
//                cout << "gs: " << gaussSum(2 * seqN - (pos+(r-curr)), val) << '\n';
                sum = (sum + gaussSum(2 * seqN - (pos+(r-curr)), val)) % MOD;
                curr = r+1;
            }
        }
    }
    return sum;
}

int main(){
//    ull ans = solve(10, 14);
//    cout << "ANSWER: " << ans << '\n';
//    return 0;
//    vector<int> vec = {INT_MIN};
//    for(int i = 1; i < 5; i++){
//        for(int j = 1; j <= i; j++){ vec.push_back(j); }
//        for(int j = i-1; j >= 1; j--){ vec.push_back(j); }
//    }
//
//    for(int i = 0; i < 1000; i++){
//        int l = rand() % vec.size();
//        int r = rand() % vec.size();
//        if(l > r){ swap(l, r); }
//        ull sol = solve(l, r);
//        ull nai = 0;
//        for(int j = l; j <= r; j++){
//            nai += vec[j];
//        }
//        if(sol != nai){
//            cout << l << ' ' << r << ' ' << sol << ' ' << nai << '\n';
//        }
//    }

    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        int l, r;
        cin >> l >> r;
        cout << solve(l, r) << '\n';
    }
    return 0;
}
