#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ull;

const ull MOD = 1000000007;
const ull MAXR = 1000000000000000000;
const ull MAXN = 1000000001;
const ull INV_2 = 500000004;

ull gaussSum(ull from, ull to){
    if(from > to){ return 0; }
    ull n = to-from+1;
    ull everySum = (from + to) % MOD;
    ull doubleSum = (everySum * n) % MOD;
    return (doubleSum * INV_2) % MOD;
}

ull fastExp(ull x, ull p){
    ull res = 1;
    while(p != 0){
        if(p%2 == 0){
            x = (x*x) % MOD;
            p /= 2;
        }else{
            res = (res*x) % MOD;
            p--;
        }
    }
    return res;
}

ull modInv(ull n){
    return fastExp(n, MOD-2);
}

ull getNumberBegin(ull n){
    return (((2 * gaussSum(1, n-1)) % MOD) - n + 2) % MOD;
}

ull getWhichNumber(ull idx){
    if(idx <= 4){ return 1 + (idx != 1); }
    ull l = 1, r = MAXN;
    while(l < r){
//        cout << l << ' ' << r << '\n';
        ull mid = (l+r)/2;
        ull midBegin = getNumberBegin(mid);
        if(l == r-1){
            if(midBegin + mid*2 - 2 >= idx){ return l; }
            return r;
        }
//        cout << "\tmid: " << mid << ", midBegin: " << midBegin << '\n';
        if(midBegin > idx){
            r = mid-1;
        }else {
            l = mid;
        }
    }
    return l;
}

void getSeqAndPos(ull idx, ull& seqN, ull& pos, ull& beginIdx, ull& endIdx, ull& val, ull& middle){
    seqN = getWhichNumber(idx);
    beginIdx = getNumberBegin(seqN);
    pos = idx - beginIdx + 1;
    middle = beginIdx + seqN - 1;
    endIdx = beginIdx + (2 * seqN) - 1 - 1;
    val = pos;
    if(pos > seqN){
        val = 2 * seqN - pos;
    }
}

/**
    1, 1, 2, 1, 1, 2, 3, 2, 1, 1, 2, 3, 4, 3, 2, 1, 1, 2, 3, 4, 5, 4, 3, 2, 1,
    |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
    1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
*/

ull solveSlow(ull l, ull r){
    ull sum = 0;
    ull seqN, pos, beginIdx, endIdx, val, middle;
    getSeqAndPos(l, seqN, pos, beginIdx, endIdx, val, middle);
    ull curr = l;
    while(curr <= r){
//        cout << curr << ' ' << seqN << ' ' << beginIdx << ' ' << middle << ' ' << endIdx << ' ' << pos << ' ' << val << ' ' << r << '\n';
        if(curr == beginIdx && endIdx <= r){
            sum = (sum + (2*gaussSum(1, seqN-1) % MOD)) % MOD;
            sum = (sum + seqN) % MOD;
            curr = endIdx + 1;
            seqN++; pos = 1; beginIdx = curr; val = 1;
            endIdx = beginIdx + (2 * seqN) - 2;
            middle = beginIdx + seqN - 1;
        }
        if(endIdx <= r){
            if(curr <= middle){ /// to the middle
                sum = (sum + gaussSum(val, seqN)) % MOD;
            }
            ull revStart = (curr <= middle ? seqN-1 : val);
            sum = (sum + gaussSum(1, revStart)) % MOD;
            curr = endIdx + 1;
            seqN++; pos = 1; beginIdx = curr; val = 1;
            endIdx = beginIdx + (2 * seqN) - 2;
            middle = beginIdx + seqN - 1;
        }else{
            if(curr <= middle){
                if(middle <= r){
                    sum = (sum + gaussSum(val, seqN)) % MOD;
                    curr = middle+1;
                    pos = seqN+1;
                    val = seqN-1;
                }else{
                    sum = (sum + gaussSum(val, pos+(r-curr))) % MOD;
                    curr = r+1;
                    val = pos+(r-curr)+1;
                    pos = pos+(r-curr)+1;
                }
            }else{
//                cout << "from: " << 2 * seqN - (pos+(r-curr)) << ", to: " << val << '\n';
//                cout << "gs: " << gaussSum(2 * seqN - (pos+(r-curr)), val) << '\n';
                sum = (sum + gaussSum(2 * seqN - (pos+(r-curr)), val)) % MOD;
                curr = r+1;
            }
        }
//        cout << "sum: " << sum << '\n';
    }
    return sum;
}

ull fastTrack(ull from, ull to){
    ull firstSum = (((gaussSum(1, from-1) * 2) % MOD) + from) % MOD;
    ull firstSumTimes = (((to-from + 1) % MOD) * firstSum) % MOD;

    ull newOnes = (gaussSum(from+1, to-1) * 3) % MOD;
    newOnes = (newOnes + to) % MOD;

    return (firstSumTimes + newOnes) % MOD;
}

ull solve(ull l, ull r){
    ull lSeq = getWhichNumber(l);
    ull lEnd = getNumberBegin(lSeq) + 2*lSeq - 2;
    ull rSeq = getWhichNumber(r);
    ull rBegin = getNumberBegin(rSeq);

//    cout << l << ' ' << lSeq << ' ' << lEnd << ' ' << r << ' ' << rSeq << ' ' << rBegin << '\n';
    if(lEnd+1 >= rBegin){
//        cout << "slow!\n";
        return solveSlow(l, r);
    }
    ull sum = (solveSlow(l, lEnd) + solveSlow(rBegin, r)) % MOD;;
    sum = (sum + fastTrack(lSeq+1, rSeq-1)) % MOD;
    return sum;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

//    vector<ull> vec = {ull_MIN};
//    for(ull i = 1; i < 9999; i++){
//        for(ull j = 1; j <= i; j++){ vec.push_back(j); }
//        for(ull j = i-1; j >= 1; j--){ vec.push_back(j); }
//        if(i%1000 == 0){ cout << "i: " << i << '\n'; }
//    }
//
//    cout << "Generated array.\n";
//
//    vector<tuple<ull, pair<ull, ull>, pair<ull, ull>>> vp;
//
//    for(ull i = 0; i < 100000; i++){
//        if(i%1000 == 0){ cout << "i: " << i << '\n'; }
//        ull l = rand() % vec.size();
//        ull r = rand() % vec.size();
//        if(l > r){ swap(l, r); }
//        if(l == 0){ i--; continue; }
//        ull sol = solveSlow(l, r);
//        ull nai = 0;
//        for(ull j = l; j <= r; j++){
//            nai += vec[j];
//            nai %= MOD;
//        }
//        if(sol != nai){
////            cout << l << ' ' << r << ' ' << sol << ' ' << nai << '\n';
//            vp.push_back({r-l+1, {l, r}, {sol, nai}});
//            cout << 'e';
//        }
//    }
//    cout << "\tsorting errors: \n";
//
//    sort(vp.begin(), vp.end());
//    for(ull i = 0; i < vp.size(); i++){
//        pair<ull, ull> p, d;
//        ull idx;
//        tie(idx, p, d) = vp[i];
//        cout << p.first << ' ' << p.second << ' ' << d.first << ' ' << d.second << '\n';
//    }
//    cout << "diagnosis complete\n";

    ull q;
    cin >> q;
    for(ull i = 0; i < q; i++){
        ull l, r; /// BQHA ull AAAAAAAAAAAAAAAAAAAAAA
        cin >> l >> r;
        cout << solve(l, r) << '\n';
    }
    return 0;
}
