#include <bits/stdc++.h>

using namespace std;

const long long mod = 1e9 + 7;
long long inv6 = -1;

long long sum1(long long to)
{
    return ((to * (to + 1)) / 2) % mod;
}

long long sum2(long long to)
{
    return (((to * (to + 1)) % mod) * (((2 * to + 1) * inv6) % mod)) % mod;
}

long long sum1Range(long long from, long long to)
{
    return (sum1(to) - sum1(from - 1) + mod) % mod;
}

long long sum2Range(long long from, long long to)
{
    return (sum2(to) - sum2(from - 1) + mod) % mod;
}

long long fastPower(long long a, long long b)
{
    if (b == 0) return 1;

    if (b % 2 == 0)
    {
        long long res = fastPower(a, b / 2);
        return (res * res) % mod;
    }

    return (a * fastPower(a, b - 1)) % mod;
}

long long findSequence(long long pos)
{
    long long l = 1;
    long long r = 1000000000;

    while (l <= r)
    {
        long long mid = (l + r) / 2;

        if (mid * mid >= pos)
        {
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    return l;
}

long long findSequenceSum(long long l, long long r, long long n)
{
    if (l <= n)
    {
        if (r <= n)
        {
            return sum1Range(l, r);
        }

        r -= n;
        r = n - r;

        return (sum1Range(l, n) + sum1Range(r, n - 1)) % mod;
    }
    else
    {
        l -= n;
        l = n - l;
        r -= n;
        r = n - r;
        return sum1Range(r, l);
    }
}

void solve()
{
    long long l, r;
    cin >> l >> r;

    long long bucketL = findSequence(l);
    long long bucketR = findSequence(r);

    //cout << "now " << bucketL << " " << bucketR << endl;

    if (bucketL == bucketR)
    {
        l -= (bucketL - 1) * (bucketL - 1);
        r -= (bucketR - 1) * (bucketR - 1);
        cout << findSequenceSum(l, r, bucketL) << "\n";
    }
    else
    {
        l -= (bucketL - 1) * (bucketL - 1);
        r -= (bucketR - 1) * (bucketR - 1);
        //cout << bucketL << " " << l << " " << 1 << " " << findSequenceSum(l, 2 * bucketL - 1, bucketL) << endl;
        //cout << bucketR << " " << r << " " << 1 << " " << findSequenceSum(1, r, bucketR) << endl;
        long long ans = findSequenceSum(l, 2 * bucketL - 1, bucketL) + findSequenceSum(1, r, bucketR);
        ans %= mod;

        if (bucketL + 1 < bucketR)
        {
            ans += sum2Range(bucketL + 1, bucketR - 1);
            ans %= mod;
        }

        cout << ans << "\n";
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int q;
    cin >> q;

    inv6 = fastPower(6, mod - 2);

    while (q--) solve();

    return 0;
}
