#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n;
vector<int> g[maxn];
int subtreeSize[maxn];

void dfsInit(int node, int par)
{
    subtreeSize[node] = 1;

    for (auto to : g[node])
    {
        if (to != par)
        {
            dfsInit(to, node);
            subtreeSize[node] += subtreeSize[to];
        }
    }
}

long long ans = 0;

set<int> ancestors;

long long cntIntervals(int from, int to, int x)
{
    long long prv = x  - from;
    long long nxt = to - x;

    return prv * nxt + prv + nxt + 1;
}

void dfs(int node, int par)
{
    if (node == 1)
    {
        ancestors.insert(node);
    }
    else
    {
        auto it = ancestors.lower_bound(node);

        int from = 0, to = n;

        if (it != ancestors.end())
        {
            to = *it;
            --to;
        }

        --it;

        from = *it;
        ++from;

        //cout << node << " " << from << " " << to << " " << cntIntervals(from, to, node) << endl;

        ans += cntIntervals(from, to, node) * (1LL * subtreeSize[node]);
        ancestors.insert(node);
    }

    for (auto to : g[node])
    {
        if (to != par)
        {
            dfs(to, node);
        }
    }

    ancestors.erase(node);
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 2; i <= n; ++i)
    {
        int p;
        cin >> p;
        g[p].push_back(i);
        g[i].push_back(p);
    }

    dfsInit(1, -1);

    ans = (1LL * subtreeSize[1]) * (1LL * n);

    dfs(1, -1);

    cout << ans << endl;

    return 0;
}
