#include <iostream>
#include <map>
#define MOD ((unsigned long)(1e9 + 7))

unsigned long group(unsigned long i)
{
    unsigned long counter = 1;
    unsigned long k = 1;
    do
    {
        if(i <= k*k)
        {
            return k;
        }
        k++;
    } while(true);
}

void gen_arr(unsigned long* arr, unsigned long len)
{
    for(unsigned long i = 1; i <= len; i++)
    {
        arr[i] = i*i;
    }
}

unsigned long sum_part_gr(unsigned long li, unsigned long ri, unsigned long gr)
{
    unsigned long peakindex = gr;
    unsigned long len = 2*gr - 1;
    unsigned long sum = 0;

    li -= (gr-1)*(gr-1);
    ri -= (gr-1)*(gr-1);

    if(li >= peakindex) // p li ri
    {
        unsigned long lval = 2*peakindex - li;
        unsigned long rval = 2*peakindex - ri;

        sum += (lval + rval) * (lval - rval + 1) / 2;
    }
    else if(ri <= peakindex) // li ri p
    {
        sum += (li + ri) * (ri - li + 1) / 2;
    }
    else //li p ri
    {
        unsigned long lval = li;
        unsigned long rval = peakindex;
        sum += (lval + rval) * (rval - lval + 1) / 2;

        if(ri == peakindex)
        {
            return sum;
        }
        lval = 2*peakindex - ri;
        rval = peakindex - 1;

        sum += (lval + rval) * (rval - lval + 1) / 2;
    }

    return sum;
}

int main()
{
    unsigned long q;
    unsigned long rmax = 0;

    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);

    std::cin >> q;
    unsigned long l[q+1], r[q+1];
    for(unsigned long i = 1; i <= q; i++)
    {
        std::cin >> l[i] >> r[i];
        if(r[i] > rmax)
        {
            rmax = r[i];
        }
    }

    unsigned long arrlen = group(rmax);
    std::map<unsigned long, unsigned long> arr;
    for(unsigned long i = 1; i < arrlen; i++)
    {
        arr.insert(std::pair<unsigned long, unsigned long>(i, i*i));
    }

    unsigned long lg, rg;   
    unsigned long sum;
    for(unsigned long i = 1; i <= q; i++)
    {
        sum = 0;
        lg = group(l[i]);
        rg = group(r[i]);
        if(rg - lg > 0)
        {
            for(unsigned long j = lg + 1; j < rg; j++)
            {
                sum += arr[j];
                sum %= MOD;
            }
            sum += sum_part_gr(l[i], lg*lg, lg);
            sum += sum_part_gr((rg-1)*(rg-1) + 1, r[i], rg);
            sum %= MOD;
        }
        else //if(lg == rg)
        {
            sum += sum_part_gr(l[i], r[i], lg);
            sum %= MOD;
        }

        std::cout << sum << "\n";
    }

    return 0;
}