#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXL = 1e6 + 10;
const ll MAXN = 1e12 + 10;
const ll MOD = 1e9 + 7;

//vector < ll > pref;

ll pref[MAXL];

ll f(ll x)
{
    ll val1 = x;
    ll val2 = x + 1;

    if(val1 % 2 == 0)
        val1 /= 2;
    else
        val2 /= 2;

    return val1 * val2 % MOD;
}

ll par(ll left, ll right)
{
    return (f(right) - f(left - 1) + MOD) % MOD;
}

ll sq(ll x)
{
    ll left = 0;
    ll right = x + 1;

    ll mid;

    while(right - left > 1)
    {
        mid = left + (right - left) / 2;

        if(mid * mid >= x)
            right = mid;
        else
            left = mid;
    }

    return right;
}

ll rem(ll pos, ll seq)
{
    if(pos == 0)
        return 0;

    if(pos <= seq)
    {
        return par(1, pos);
    }
    else
    {
        return (par(1, seq) + par(2 * seq - pos, seq - 1)) % MOD;
    }
}

ll query(ll left, ll right)
{
    ll result = 0;

    ll seq1 = sq(left);
    ll seq2 = sq(right);

    ll pos1 = seq1 * seq1 - left + 1;
    ll pos2 = right - (seq2 - 1) * (seq2 - 1);

    ll in1, in2;

    if(pos1 != 2 * seq1 - 1)
    {
        in1 = seq1 + 1;
    }
    else
    {
        in1 = seq1;
    }

    if(pos2 != 2 * seq2 - 1)
    {
        in2 = seq2 - 1;
    }
    else
    {
        in2 = seq2;
    }

    if(in1 <= in2 && left != right)
    {
        result = (result + (pref[in2] - pref[in1 - 1] + MOD) % MOD) % MOD;

        if(pos1 != 2 * seq1 - 1)
        {
            result = (result + rem(pos1, seq1)) % MOD;
        }

        if(pos2 != 2 * seq2 - 1)
        {
            result = (result + rem(pos2, seq2)) % MOD;
        }
    }
    else
    {
        pos1 = (2 * seq1 - pos1);
        result = (result + rem(pos2, seq2)) % MOD;
        result = (result - rem(pos1 - 1, seq1) + MOD) % MOD;
    }

    return result;
}

void precomp()
{
    for(ll i = 1; i * i <= MAXN; i++)
    {
        pref[i] = (pref[i - 1] + i * i % MOD) % MOD;
    }
}


void process_queries()
{
    ll q;
    cin >> q;

    for(ll i = 1; i <= q; i++)
    {
        ll left, right;
        cin >> left >> right;

        //assert(left == right);

        cout << query(left, right) << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    precomp();
   //gen();
    process_queries();

    return 0;
}
