#include<bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXL = 1e6 + 10;
const ll MAXN = 1e12 + 10;
const ll MOD = 1e9 + 7;

//vector < ll > pref;

ll pref[MAXL];
vector < ll > pref2;

int q;

ll maxr;

pair < ll, ll > queries[100010];

ll f(ll x)
{
    ll val1 = x;
    ll val2 = x + 1;

    if(val1 % 2 == 0)
        val1 /= 2;
    else
        val2 /= 2;

    return val1 * val2 % MOD;
}

ll par(ll left, ll right)
{
    return (f(right) - f(left - 1) + MOD) % MOD;
}

ll rem(ll pos, ll seq)
{
    if(pos == 0)
        return 0LL;

    if(pos <= seq)
    {
        return par(1, pos) % MOD;
    }
    else
    {
        return (par(1, seq) + par(2 * seq - pos, seq - 1)) % MOD;
    }
}

ll query(ll left, ll right)
{
    if(maxr <= 1000000)
        return (pref2[right] - pref2[left - 1] + MOD) % MOD;

    ll result = 0;

    ll seq1 = sqrt(left);
    ll seq2 = sqrt(right);

    if(seq1 * seq1 < left)
        seq1++;

    if(seq2 * seq2 < right)
        seq2++;

    ll pos1 = seq1 * seq1 - left + 1;
    ll pos2 = right - (seq2 - 1) * (seq2 - 1);

    ll in1, in2;

    if(pos1 != 2 * seq1 - 1)
    {
        in1 = seq1 + 1;
    }
    else
    {
        in1 = seq1;
    }

    if(pos2 != 2 * seq2 - 1)
    {
        in2 = seq2 - 1;
    }
    else
    {
        in2 = seq2;
    }

    if(in1 <= in2 && left != right)
    {
        result = (result + (pref[in2] - pref[in1 - 1] + MOD) % MOD) % MOD;

        if(pos1 != 2 * seq1 - 1)
        {
            result = (result + rem(pos1, seq1)) % MOD;
        }

        if(pos2 != 2 * seq2 - 1)
        {
            result = (result + rem(pos2, seq2)) % MOD;
        }
    }
    else
    {
        pos1 = (2 * seq1 - pos1);
        result = (result + rem(pos2, seq2)) % MOD;
        result = (result - rem(pos1 - 1, seq1) + MOD) % MOD;
    }

    return result;
}

void precomp()
{
    for(ll i = 1; (i - 1) * (i - 1) <= MAXN; i++)
    {
        pref[i] = (pref[i - 1] + i * i % MOD) % MOD;
    }
}
void gen()
{
    vector < ll > v;

    int cnt = 1;

    while(v.size() <= 1000000)
    {
        for(int i = 1; i <= cnt; i++)
        {
            v.push_back(i);
        }
        for(int i = cnt - 1; i >= 1; i--)
        {
            v.push_back(i);
        }

        cnt++;
    }

    pref2.resize(v.size() + 1);

    for(int i = 1; i <= v.size(); i++)
    {
        pref2[i] = (pref2[i - 1] + v[i - 1]) % MOD;
    }
}

void read()
{
    cin >> q;

    for(int i = 1; i <= q; i++)
    {
        cin >> queries[i].first >> queries[i].second;
        maxr = max(maxr, queries[i].second);
    }
}

void process_queries()
{
    for(int i = 1; i <= q; i++)
    {
        cout << query(queries[i].first, queries[i].second) << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();

    if(maxr <= 1000000)
        gen();
    else
        precomp();

    process_queries();

    return 0;
}
